package be.iminds.ilabt.jfed.rspec;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.Collections;
import java.util.List;

/**
 * config for AdvertisementBasedRspecGenerator
 */
public class AdvertisementBasedRspecGeneratorConfig {
    public static class NodeInfo {
        public final int count;
        @Nonnull public final String clientIdBase;
        @Nullable public final String ansibleGroup;
        @Nullable public final String diskImage;
        @Nullable public final List<String> componentId;
        @Nullable public final String sliverType;
        @Nullable public final String hardwareTypeFilter;
        @Nullable public final String availableFilter;

        public NodeInfo(int count,
                        @Nullable String clientIdBase,
                        @Nullable String ansibleGroup,
                        @Nullable String diskImage,
                        @Nullable List<String> componentId,
                        @Nullable String sliverType,
                        @Nullable String hardwareTypeFilter,
                        @Nullable String availableFilter) {
            this.count = count;
            this.clientIdBase = clientIdBase == null ? "node" : clientIdBase;
            this.ansibleGroup = ansibleGroup;
            this.diskImage = diskImage;
            this.componentId = componentId;
            this.sliverType = sliverType;
            this.hardwareTypeFilter = hardwareTypeFilter;
            this.availableFilter = availableFilter;
        }

        public NodeInfo(int count,
                        @Nullable String clientIdBase,
                        @Nullable String ansibleGroup,
                        @Nullable String diskImage,
                        @Nullable String componentId,
                        @Nullable String sliverType,
                        @Nullable String hardwareTypeFilter,
                        @Nullable String availableFilter) {
            this(count, clientIdBase, ansibleGroup, diskImage, Collections.singletonList(componentId),
                 sliverType, hardwareTypeFilter, availableFilter);
        }
    }
}
